WSDD2(8)

NAME
wsdd2 - server to provide WSDD/LLMNR services to clients

SYNOPSIS

wsddd2 [-h] [-d] [-4] [-6] [-u] [-t] [-l] [-w] [-L] [-W] [-i <intrerface>] [-H <hostname>] [-N <netbiosname>] [-G <workgroup>] [-b <kvlist>]

DESCRIPTION

wsdd2 is the server daemon that provides WSDD (Web Services Dynamic Discovery) as well as LLMNR (Link-Local Multicast Name Resolution) services primarily for Windows clients on both IPv4 and IPv6.

wsdd2's WSDD protocol handler multicasts Hello and Bye messages by itself over UDP, responds with ProbeMatch and ResolveMatch messages in response to Probe and Resolve queries respectively over UDP, and sends HTTP reponse messages to HTTP property query POST messages over TCP.

wsdd2's LLMNR protocol handler responds to LLMNR multicast query messages over UDP and to LLMNR unicast query messages over TCP.

wsdd2 uses and listens on the following ports:

3702 UDP
    WSDD multicast group addresses 239.255.255.250 and ff02::c.

3702 TCP
    WSDD property query over HTTP.

5355 UDP
    LLMNR query multicast group addresses 224.0.0.252 and ff02::1:3.

5355 TCP
    LLMNR query unicast.

OPTIONS

-h
    Display a simple help messasge to stdout including currently in effect parameters' values.

-d
    Fork off a child process to become daemon.

-4 -6
    Respond only to IPv4 and IPv6 respectively. Default is equivalent to "-4 -6".

-u -t
    Respond only to UDP and TCP respectively. Default is equivalent to "-u -t".

-l -w
    Respond only to LLMNR and WSDD respectively. Default is equivalent to "-l -w".

-L
    Print out LLMNR debug messages to stdout. Multiple -L's to increment debug level.

-W
    Print out WSDD debug messages to stdout. Multiple -W's to increment debug level.

-i <interface>
    Use only specified interface to reply to incoming requests. Specifying "any" or leaving option out causes wsdd2 to listen on every IPv4 or IPv6 capable interface excluding those that have names matching LeafNets, docker*, veth*, tun*, ppp*, zt*.

-H <hostname>
    Use specified string as host name instead of first label before '.' of system host name retrieved with gethostname(3) or uname(3) functions.

-N <nebiosname>
    Use specified string as NETBIOS machine name instead of value returned by
    testparm -s --parameter-name="netbios name" command or system host name.

-G <workgroup>
    Use specified string as workgroup name instead of value returned by
    testparm -s --parameter-name="workgroup" command or "WORKGROUP" default value.

-b "key1:val1,key2:val2,..."
    Set WSDD query over HTTP response values in a comma-delimited list. The valid/necessary keys are: vendor, model, serial, sku, vendorurl, modelurl, presentationurl.
    This option overrides /proc/sys/dev/boot/info readouts.

WSDD PROPERTY QUERY RESPONSE

wsdd2 responds to property queries using the following values over HTTP. If a value may be set with multiple methods, the latter in the method list has precedence.

Vendor
    Value retrieved from /proc/sys/dev/boot/info or set with the -b option.

Model
    Value retrieved from /proc/sys/dev/boot/info or set with the -b option.

Serial
    Value retrieved from /proc/sys/dev/boot/info or set with the -b option or 0.

SKU
    Value retrieved from /proc/sys/dev/boot/info or set with the -b option.

ModelURL
    Value set with the -b option.

VendorURL
    Value set with the -b option.

PresentationURL
    Value set with the -b option.

FILES

/etc/samba/smb.conf
    This is the default location of the Samba configuration file.

/etc/machine-id
    A single line text file containing a host-unique UUID in the form of 32 lowercase hex digits used by systemd-id128(1). See machine-id(5).

/proc/sys/dev/boot/info
    A list of key:value entries for WSDD query over HTTP response values.

SIGNALS

Sending the wsdd2 a SIGHUP will cause it to restart. Restarting will bind daemon to new interfaces but will not reparse testparm(1)'s output and other parameters, nor re-evaluate command line options - stop and start the daemon again for this. Address change, addition, or deletion on a network interface will restart wsdd2 as well.

SIGTERM and SIGINT will terminate wsdd2 gracefully with WSDD "Bye" messages.

SEE ALSO

testparm(1), systemd-id128(1).

STANDARDS

The WSDD protocol is described in detail in "Web Services Dynamic Discovery (WS-Discovery) Version 1.1" OASYS Standard, 1 July 2009
http://docs.oasis-open.org/ws-dd/discovery/1.1/os/wsdd-discovery-1.1-spec-os.html

LLMNR complies with RFC4795.

AUTHOR

Hiro Sugawara at NETGEAR authored the code. wsdd2 was inspired by and uses some code from the wsdd/llmnr extension for smbd created by Tobias Waldvogel, Jose M. Prieto, and possibly other contributors.